//########## Lego Quad Bike

//### Effects

datablock ParticleData(gc_LegoQuadTrailParticle)
{
  dragCoefficient = 4;
  gravityCoefficient = -0.5;
  inheritedVelFactor = 0;
  constantAcceleration = 0;
  lifetimeMS = 1000;
  lifetimeVarianceMS = 500;
  textureName = "base/data/particles/cloud";
  spinSpeed = 10;
  spinRandomMin = -50;
  spinRandomMax = 50;
  colors[0] = "0.8 0.8 0.8 0.2";
  colors[1] = "0.8 0.8 0.8 0";
  sizes[0] = 0.4;
  sizes[1] = 0.8;
  useInvAlpha = false;
};

datablock ParticleEmitterData(gc_LegoQuadTrailEmitter)
{
  uiName = "";
  ejectionPeriodMS = 5;
  ejectionVelocity = 10;
  velocityVariance = 5;
  thetaMin = 0;
  thetaMax = 2;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_LegoQuadTrailParticle";
};

datablock ShapeBaseImageData(gc_LegoQuadTrailLeftImage)
{
  shapeFile = "base/data/shapes/empty.dts";
  emap = false;
  mountPoint = 1;

  stateName[0] = "FireA";
  stateTransitionOnTimeout[0] = "FireA";
  stateWaitForTimeout[0] = true;
  stateTimeoutValue[0] = 1000;
  stateEmitter[0] = gc_LegoQuadTrailEmitter;
  stateEmitterTime[0] = 1000;
};

datablock ShapeBaseImageData(gc_LegoQuadTrailRightImage)
{
  shapeFile = "base/data/shapes/empty.dts";
  emap = false;
  mountPoint = 2;

  stateName[0] = "FireA";
  stateTransitionOnTimeout[0] = "FireA";
  stateWaitForTimeout[0] = true;
  stateTimeoutValue[0] = 1000;
  stateEmitter[0] = gc_LegoQuadTrailEmitter;
  stateEmitterTime[0] = 1000;
};

datablock ParticleData(gc_tireParticle)
{
  dragCoefficient = 8;
  gravityCoefficient = 0;
  inheritedVelFactor = 0.2;
  constantAcceleration = 0;
  lifetimeMS = 1000;
  lifetimeVarianceMS = 500;
  textureName = "base/data/particles/cloud";
  spinSpeed = 10;
  spinRandomMin = -50;
  spinRandomMax = 50;
  colors[0] = "0.4 0.4 0.4 0.3";
  colors[1] = "0.2 0.2 0.2 0";
  sizes[0] = 2;
  sizes[1] = 6;
  useInvAlpha = true;
};

datablock ParticleEmitterData(gc_tireEmitter)
{
  uiName = "";
  ejectionPeriodMS = 50;
  periodVarianceMS = 25;
  ejectionVelocity = 2;
  velocityVariance = 1;
  ejectionOffset = 0;
  thetaMin = 89;
  thetaMax = 90;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_tireParticle";
  useEmitterColors = true;
};

datablock ParticleData(gc_vehicleDamageParticle)
{
  dragCoefficient = 8;
  gravityCoefficient = -2;
  inheritedVelFactor = 0.2;
  constantAcceleration = 0;
  lifetimeMS = 1000;
  lifetimeVarianceMS = 500;
  textureName = "base/data/particles/cloud";
  spinSpeed = 10;
  spinRandomMin = -50;
  spinRandomMax = 50;
  colors[0] = "0 0 0 0";
  colors[1] = "0 0 0 0.5";
  colors[2] = "0 0 0 0";
  sizes[0] = 3;
  sizes[1] = 4;
  sizes[2] = 6;
  times[0] = 0;
  times[1] = 0.2;
  times[2] = 1;
  useInvAlpha = true;
};

datablock ParticleEmitterData(gc_vehicleDamageEmitter)
{
  uiName = "";
  ejectionPeriodMS = 50;
  periodVarianceMS = 25;
  ejectionVelocity = 2;
  velocityVariance = 1;
  ejectionOffset = 0;
  thetaMin = 89;
  thetaMax = 90;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_vehicleDamageParticle";
  useEmitterColors = true;
};

//### Vehicle

datablock WheeledVehicleTire(gc_LegoQuadTire)
{
  shapeFile = "./tire.dts";
  mass = 1;
  radius = 0.7;
  staticFriction = 1.5;
  kineticFriction = 1.5;
  restitution = 0.5;
  lateralForce = 15000;
  lateralDamping = 1000;
  lateralRelaxation = 0.01;
  longitudinalForce = 10000;
  longitudinalDamping = 1000;
  longitudinalRelaxation = 0.01;
};

datablock WheeledVehicleSpring(gc_LegoQuadSpring)
{
  length = 0.4;
  force = 1200;
  damping = 200;
  antiSwayForce = 10;
};

datablock WheeledVehicleData(gc_LegoQuadVehicle)
{
  uiName = "Lego Quad";
  category = "Vehicles";
  displayName = "";
  shapeFile = "./quad.dts";
  emap = true;
  minMountDist = 2;
  numMountPoints = 1;
  mountThread[0] = "sit";
  numWheels = 4;
  engineTorque = 2000;
  engineBrake = 500;
  brakeTorque = 2000;
  maxWheelSpeed = 30;
  maxDamage = 100;
  destroyedLevel = 100;
  speedDamageScale = 1.04;
  collDamageThresholdVel = 20;
  collDamageMultiplier = 0.02;
  massCenter = "0 0 -0.5";
  maxSteeringAngle = 0.7;
  integration = 4;
  tireEmitter = gc_tireEmitter;
  cameraRoll = false;
  cameraMaxDist = 8;
  cameraOffset = 2;
  cameraLag = 0;
  cameraDecay = 0.75;
  cameraTilt = 0.15;
  collisionTol = 0.1;
  contactTol = 0.1;
  useEyePoint = false;
  defaultTire = gc_LegoQuadTire;
  defaultSpring = gc_LegoQuadSpring;
  mass = 100;
  density = 5;
  drag = 1.6;
  bodyFriction = 0.6;
  bodyRestitution = 0.6;
  minImpactSpeed = 10;
  softImpactSpeed = 10;
  hardImpactSpeed = 20;
  groundImpactMinSpeed = 10;
  rollForce = 0;
  yawForce = 100;
  pitchForce = 1000;
  rotationalDrag = 0.2;
  steeringAutoReturn = true;
  steeringAutoReturnRate = 0.9;
  steeringAutoReturnMaxSpeed = 10;
  steeringUseStrafeSteering = true;
  steeringStrafeSteeringRate = 0.05;
  maxEnergy = 100;
  jetForce = 3000;
  minJetEnergy = 30;
  jetEnergyDrain = 2;
  splash = vehicleSplash;
  splashVelocity = 4;
  splashAngle = 67;
  splashFreqMod = 300;
  splashVelEpsilon = 0.6;
  bubbleEmitTime = 1.4;
  splashEmitter[0] = vehicleFoamDropletsEmitter;
  splashEmitter[1] = vehicleFoamEmitter;
  splashEmitter[2] = vehicleBubbleEmitter;
  mediumSplashSoundVelocity = 10;
  hardSplashSoundVelocity = 20;
  exitSplashSoundVelocity = 5;
  justcollided = 0;
  rideable = true;
  lookUpLimit = 0.65;
  lookDownLimit = 0.45;
  paintable = true;
  damageEmitter[0] = gc_vehicleDamageEmitter;
  damageEmitterOffset[0] = "0 -2 0";
  damageLevelTolerance[0] = 0.5;
  damageEmitter[1] = VehicleBurnEmitter;
  damageEmitterOffset[1] = "0 -2 0";
  damageLevelTolerance[1] = 0.9;
  numDmgEmitterAreas = 1;
  initialExplosionProjectile = VehicleExplosionProjectile;
  initialExplosionOffset = 0;
  burnTime = 4000;
  finalExplosionProjectile = FinalVehicleExplosionProjectile;
  finalExplosionOffset = 0.5;
  minRunOverSpeed = 4;
  runOverDamageScale = 8;
  runOverPushScale = 1.2;
  protectPassengersBurn = false;
  protectPassengersRadius = false;
  protectPassengersDirect = false;
};

//### Functions

function gc_LegoQuadVehicle::onAdd(%this,%obj)
{
  parent::onAdd(%this,%obj);
  %obj.mountImage(gc_LegoQuadTrailLeftImage,1);
  %obj.mountImage(gc_LegoQuadTrailRightImage,2);
}

package gc_LegoQuadVehicle
{
  function armor::onMount(%this,%obj,%col,%slot)
  {
    parent::onMount(%this,%obj,%col,%slot);
    if(%col.getDataBlock() == gc_LegoQuadVehicle.getID())
    {
      %obj.playThread(2,armreadyboth);
    }
  }
};
activatePackage(gc_LegoQuadVehicle);
